## ros-kinetic-mcl-3dl 0.5.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)
project(mcl_3dl)

set(CATKIN_DEPENDS
  roscpp

  pcl_ros
  tf2
  tf2_geometry_msgs
  tf2_ros
  tf2_sensor_msgs

  diagnostic_updater
  geometry_msgs
  mcl_3dl_msgs
  nav_msgs
  sensor_msgs
  std_msgs
  std_srvs
  visualization_msgs
)

find_package(catkin REQUIRED COMPONENTS ${CATKIN_DEPENDS})
find_package(Eigen3 REQUIRED)
find_package(PCL 1.7.2 REQUIRED
  COMPONENTS
    core
    filters
    kdtree
)
find_package(Boost REQUIRED COMPONENTS chrono)
catkin_package(
  INCLUDE_DIRS include
  CATKIN_DEPENDS ${CATKIN_DEPENDS}
)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(include ${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${PCL_INCLUDE_DIR})
add_definitions(${PCL_DEFINITIONS})


# Workaround for debian stretch build (https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=894656)
list(REMOVE_ITEM PCL_LIBRARIES
  "vtkGUISupportQt"
  "vtkGUISupportQtOpenGL"
  "vtkGUISupportQtSQL"
  "vtkGUISupportQtWebkit"
  "vtkViewsQt"
  "vtkRenderingQt"
)

# Workaround for the bug in PCL<1.8.1 (https://github.com/PointCloudLibrary/pcl/issues/1406)
remove_definitions(-DDISABLE_LIBUSB-1.0)

# Workaround for PCL-1.7 problem on C++11 (https://github.com/PointCloudLibrary/pcl/issues/619)
# Debug build without optimization causes Segmentation fault.
# Set default build type to Release and add -O1 to CXX_FLAGS_DEBUG.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O1")

if(PCL_VERSION VERSION_LESS 1.8.0)
  add_definitions(-DBACKPORT_PCL_VOXEL_GRID)
endif()

# Binary installed pcl provided by Linux distro is built with -march=native
# which causes a lot of compatibility problems.
# Define PCL_NO_PRECOMPILE to disable using the binary version.
add_definitions(-DPCL_NO_PRECOMPILE)


add_executable(mcl_3dl
  src/cloud_accum.cpp
  src/lidar_measurement_model_beam.cpp
  src/lidar_measurement_model_likelihood.cpp
  src/mcl_3dl.cpp
  src/parameters.cpp
  src/point_types.cpp
)
target_link_libraries(mcl_3dl ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${PCL_LIBRARIES})
add_dependencies(mcl_3dl ${catkin_EXPORTED_TARGETS})


if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  find_package(rosunit REQUIRED)
  add_subdirectory(test)

  find_package(roslint REQUIRED)
  roslint_cpp()
  roslint_add_test()
endif()


install(TARGETS mcl_3dl
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)
install(DIRECTORY launch config
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-kinetic-mcl-3dl (0.5.4-1xenial) xenial; urgency=high

  * Add odom/imu/cloud_queue_size params (#375 <https://github.com/at-wat/mcl_3dl/issues/375>)
  * Fix flaky tests (#376 <https://github.com/at-wat/mcl_3dl/issues/376>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Sun, 07 Mar 2021 00:00:00 -0000

ros-kinetic-mcl-3dl (0.5.3-1xenial) xenial; urgency=high

  * Fix cloud accum reset on map update (#371 <https://github.com/at-wat/mcl_3dl/issues/371>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 26 Feb 2021 00:00:00 -0000

ros-kinetic-mcl-3dl (0.5.2-1xenial) xenial; urgency=high

  * Fix potential "Time is out of dual 32-bit range" error (#367 <https://github.com/at-wat/mcl_3dl/issues/367>)
  * Update assets to v0.1.4 (#365 <https://github.com/at-wat/mcl_3dl/issues/365>)
  * Improve test stability (#363 <https://github.com/at-wat/mcl_3dl/issues/363>)
  * Update assets to v0.1.3 (#362 <https://github.com/at-wat/mcl_3dl/issues/362>)
  * Update assets to v0.1.2 (#361 <https://github.com/at-wat/mcl_3dl/issues/361>)
  * Migrate to GitHub Actions (#357 <https://github.com/at-wat/mcl_3dl/issues/357>)
  * Update assets to v0.0.10 (#356 <https://github.com/at-wat/mcl_3dl/issues/356>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 15 Jan 2021 00:00:00 -0000

ros-kinetic-mcl-3dl (0.5.1-1xenial) xenial; urgency=high

  * Make hit_range independent from grid size and fix DDA hit/miss state (#350 <https://github.com/at-wat/mcl_3dl/issues/350>)
  * Fix crushing when lidar poses are out of map (#351 <https://github.com/at-wat/mcl_3dl/issues/351>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 26 Oct 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.5.0-1xenial) xenial; urgency=high

  * Fix crushing when new map is received (#347 <https://github.com/at-wat/mcl_3dl/issues/347>)
  * Ease condition for test of PointCloudSamplerWithNormal (#344 <https://github.com/at-wat/mcl_3dl/issues/344>)
  * Add faster raycast algorithm using DDA (#343 <https://github.com/at-wat/mcl_3dl/issues/343>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Thu, 15 Oct 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.4.0-1xenial) xenial; urgency=high

  * Fix typos of license (#340 <https://github.com/at-wat/mcl_3dl/issues/340>)
  * Add PointCloudSamplerWithNormal (#339 <https://github.com/at-wat/mcl_3dl/issues/339>)
  * Contributors: Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 07 Oct 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.3.0-1xenial) xenial; urgency=high

  * Switch beam model by map label field (#334 <https://github.com/at-wat/mcl_3dl/issues/334>)
  * Update test script for latest catkin (#333 <https://github.com/at-wat/mcl_3dl/issues/333>)
  * Remove references to sensor_msgs::PointCloud (#332 <https://github.com/at-wat/mcl_3dl/issues/332>)
  * Update assets to v0.0.9 (#331 <https://github.com/at-wat/mcl_3dl/issues/331>)
  * Improve expansion resetting/global localization test stability (#330 <https://github.com/at-wat/mcl_3dl/issues/330>)
  * Fix global localization test parameter (#328 <https://github.com/at-wat/mcl_3dl/issues/328>)
  * Avoid rate limit when fetching gh-ph-comment (#329 <https://github.com/at-wat/mcl_3dl/issues/329>)
  * Update gh-pr-comment (#327 <https://github.com/at-wat/mcl_3dl/issues/327>)
  * Retry codecov script download (#326 <https://github.com/at-wat/mcl_3dl/issues/326>)
  * Improve test coverage (#325 <https://github.com/at-wat/mcl_3dl/issues/325>)
  * Merge rostest coverage profiles (#324 <https://github.com/at-wat/mcl_3dl/issues/324>)
  * Contributors: Atsushi Watanabe, f-fl0

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Mon, 07 Sep 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.2.5-1xenial) xenial; urgency=high

  * Add validation for orientation of initial pose (#317 <https://github.com/at-wat/mcl_3dl/issues/317>)
  * Update CI scripts (#318 <https://github.com/at-wat/mcl_3dl/issues/318>)
  * Contributors: Atsushi Watanabe, Yuta Koga

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Wed, 27 May 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.2.4-1xenial) xenial; urgency=high

  * Fix resampling failure of last particle (#313 <https://github.com/at-wat/mcl_3dl/issues/313>)
  * Retry gpg keyserver on prerelease test (#312 <https://github.com/at-wat/mcl_3dl/issues/312>)
  * Add filter class for Vec3 (#311 <https://github.com/at-wat/mcl_3dl/issues/311>)
  * Refactor math functions (#310 <https://github.com/at-wat/mcl_3dl/issues/310>)
  * Fix deprecation warning (#309 <https://github.com/at-wat/mcl_3dl/issues/309>)
  * Split parameter loader code (#307 <https://github.com/at-wat/mcl_3dl/issues/307>)
  * Contributors: Atsushi Watanabe, Naotaka Hatao

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Fri, 08 May 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.2.3-1xenial) xenial; urgency=high

  * Update assets to v0.0.8 (#303 <https://github.com/at-wat/mcl_3dl/issues/303>)
  * Fix flaky rostest nodes (#302 <https://github.com/at-wat/mcl_3dl/issues/302>)
  * Update E2E test parameters (#301 <https://github.com/at-wat/mcl_3dl/issues/301>)
  * Refactor CI scripts (#300 <https://github.com/at-wat/mcl_3dl/issues/300>)
  * Add Noetic CI job (#296 <https://github.com/at-wat/mcl_3dl/issues/296>)
  * Fix initialization of accumulated cloud header (#299 <https://github.com/at-wat/mcl_3dl/issues/299>)
  * Support Noetic (#297 <https://github.com/at-wat/mcl_3dl/issues/297>)
  * Contributors: Atsushi Watanabe

 -- Atsushi Watanabe <atsushi.w@ieee.org>  Tue, 07 Apr 2020 00:00:00 -0000

ros-kinetic-mcl-3dl (0.2.2-1xenial) xenial; urgency=high

  * Make average number of accumulated clouds accurate (#293 <https://github.com/at-wat/mcl_3dl/issues/293>)
  * Fix latching flag in demo bag (#294 <https://github.com/at-wat/mcl_3dl/issues/294>)
  * Fix cloud accumulation logic (#290 <https://github.com/at-wat/mcl_3dl/issues/290>)


=== debian/control ===
Source: ros-kinetic-mcl-3dl
Section: misc
Priority: optional
Maintainer: Atsushi Watanabe <atsushi.w@ieee.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-kinetic-catkin, ros-kinetic-diagnostic-updater, ros-kinetic-geometry-msgs, ros-kinetic-mcl-3dl-msgs, ros-kinetic-nav-msgs, ros-kinetic-pcl-ros, ros-kinetic-roscpp, ros-kinetic-roslint, ros-kinetic-rostest, ros-kinetic-rosunit, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf2, ros-kinetic-tf2-geometry-msgs, ros-kinetic-tf2-ros, ros-kinetic-tf2-sensor-msgs, ros-kinetic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-mcl-3dl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-kinetic-diagnostic-updater, ros-kinetic-geometry-msgs, ros-kinetic-mcl-3dl-msgs, ros-kinetic-nav-msgs, ros-kinetic-pcl-ros, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-tf2, ros-kinetic-tf2-geometry-msgs, ros-kinetic-tf2-ros, ros-kinetic-tf2-sensor-msgs, ros-kinetic-visualization-msgs
Description: 3-D/6-DOF localization for mobile robots with 3-D LIDAR(s)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-mcl-3dl//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
